package com.detectdoc.opencv_document_detection

import android.app.Activity
import android.content.Intent
import android.util.Log
import com.detectdoc.opencv_document_detection.scan.ScanActivity
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar

class OpencvDocumentDetectionPlugin(var activity: Activity): MethodCallHandler, PluginRegistry.ActivityResultListener {
  internal val CARD_SCAN_CODE = 2500
  internal var result: MethodChannel.Result? = null


  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "opencv_document_detection")
      channel.setMethodCallHandler(OpencvDocumentDetectionPlugin(registrar.activity()))
    }
  }

  override fun onMethodCall(call: MethodCall, result: Result) {
    this.result = result
    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    }else if (call.method == "scanIdCard") {
      var strMessage = call.argument<String>("message")
      var titleEditScanHeaderText = call.argument<String>("titleEditScanHeaderText")
      var rightNextButtonText = call.argument<String>("rightNextButtonText")
      var titleReviewHeaderText = call.argument<String>("titleReviewHeaderText")
      var rightConfirmButtonText = call.argument<String>("rightConfirmButtonText")
      var intent = Intent(activity, ScanActivity::class.java)
      intent.putExtra("message",strMessage)
      intent.putExtra("titleEditScanHeaderText",titleEditScanHeaderText)
      intent.putExtra("rightNextButtonText",rightNextButtonText)
      intent.putExtra("titleReviewHeaderText",titleReviewHeaderText)
      intent.putExtra("rightConfirmButtonText",rightConfirmButtonText)
      activity.startActivityForResult(intent,CARD_SCAN_CODE)
    } else {
      result.notImplemented()
    }
  }

  override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?): Boolean {
    Log.e("methodCalled","MainActivity")
    if (resultCode == CARD_SCAN_CODE) {
      if (data == null) {
        result!!.error("404", "Camera Closed", "")
      } else {
        result!!.success(data!!.getStringExtra("path"))
      }
    }
    return true
  }
}
