package com.detectdoc.opencv_document_detection.crop
import android.content.Intent
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.TextView
import com.detectdoc.opencv_document_detection.R
import com.detectdoc.opencv_document_detection.base.BaseActivity
import com.detectdoc.opencv_document_detection.preview.PreviewActivity
import com.detectdoc.opencv_document_detection.view.PaperRectangle
import kotlinx.android.synthetic.main.activity_crop.*

class CropActivity : BaseActivity(), ICropView.Proxy {
    val CROP_CODE = 1520
    lateinit var relativeCropBack : RelativeLayout
    private lateinit var mPresenter: CropPresenter
    var isFirstTime = true
    lateinit var txteditScan: TextView
    lateinit var txtNext:TextView
    lateinit var titleReviewHeaderText:String
    lateinit var rightConfirmButtonText:String
    override fun prepare() {
        next.setOnClickListener {
            //            if(mPresenter.isCropped){
//                goToNextActivity()
//            }
//            else{
            mPresenter.crop()
//            }
        }
        rotate.setOnClickListener { mPresenter.rotateBitmap(90.toFloat()) }
    }
    override fun provideContentViewId(): Int = R.layout.activity_crop
    override fun initPresenter() {
        relativeCropBack = findViewById(R.id.relativeCropBack)
        txteditScan = findViewById(R.id.txteditScan)
        txtNext = findViewById(R.id.next)
        var intent = intent
        if (intent!=null){
            txteditScan.text = intent.getStringExtra("titleEditScanHeaderText")
            txtNext.text = intent.getStringExtra("rightNextButtonText")
            titleReviewHeaderText = intent.getStringExtra("titleReviewHeaderText")
            rightConfirmButtonText = intent.getStringExtra("rightConfirmButtonText")
        }
        mPresenter = CropPresenter(this, this)
        relativeCropBack.setOnClickListener {
            finish()
        }
    }
    override fun getPaper(): ImageView = paper
    override fun getPaperRect(): PaperRectangle = paper_rect as PaperRectangle
    override fun getCroppedPaper(): ImageView = picture_cropped
    override fun goToNextActivity() {
        var intent = Intent(this, PreviewActivity::class.java)
        intent.putExtra("titleReviewHeaderText",titleReviewHeaderText)
        intent.putExtra("rightConfirmButtonText",rightConfirmButtonText)
        startActivityForResult(intent,2651)
        //startActivityForResult(Intent(this,PreviewActivity::class.java),2651)
    }
    override fun onResume() {
        super.onResume()
        if(isFirstTime) {
            isFirstTime = false
        }
        else{
            mPresenter.initAgain()
        }
    }
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if(requestCode==2651){
            if(data!=null){
                var mIntent = Intent()
                mIntent.putExtra("path",data.getStringExtra("path"))
                setResult(CROP_CODE, mIntent)
                finish()
            }
        }
    }
}



