import 'dart:async';

import 'package:flutter/services.dart';

class OpencvDocumentDetection {
  static const MethodChannel _channel =
      const MethodChannel('opencv_document_detection');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> scanIDCard(
      String message,
      String editScan,
      String next,
      String review,
      String confirm ) async
  {
    final String filePath = await _channel.invokeMethod('scanIdCard',
        {
          "message":message,
          "titleEditScanHeaderText":editScan,
          "rightNextButtonText":next,
          "titleReviewHeaderText":review,
          "rightConfirmButtonText":confirm
        });
    return filePath;
  }

}
